package sample;

import javax.ejb.Stateless;
import javax.jws.WebService;

/**
 * Session Bean implementation class for: ConvertTemperature
 *
 */
@Stateless
@WebService
public class ConvertTemperature {
	/**
	  * Converts a temperature in celsius to a temperature in
	  * fahrenheit. 
	 */
	public double celsiusToFahrenheit( double celsiusValue ) 
	{
	  return (celsiusValue * 9.0 / 5.0) + 32.0;
	}
	
	/**
	  * Converts a temperature in fahrenheit to a temperature in
	  * celsius. 
	 */
	public double fahrenheitToCelsius( double fahrenheitValue )
	{
	  return (fahrenheitValue - 32.0) * 5.0 / 9.0;
	}
}
